diff -Naur test-for-latech/include/asm-arm/unistd.h testqf-for-latech/include/asm-arm/unistd.h
--- test-for-latech/include/asm-arm/unistd.h	2004-06-11 07:40:27.000000000 -0400
+++ testqf-for-latech/include/asm-arm/unistd.h	2004-06-11 07:47:34.000000000 -0400
@@ -259,6 +259,44 @@
 #define __NR_fremovexattr		(__NR_SYSCALL_BASE+237)
 #endif
 #define __NR_tkill			(__NR_SYSCALL_BASE+238)
+/* DWCS related calls. */
+#define __NR_load_scheduler     	(__NR_SYSCALL_BASE+239)	/* Added by Rich West --RW--.  */
+#define __NR_unload_scheduler      	(__NR_SYSCALL_BASE+240)	/* Added by Rich West --RW--.  */
+#define __NR_DWCS_scheduler         	(__NR_SYSCALL_BASE+241)	/* Added by Rich West --RW--.  */
+#define __NR_update_utilization       	(__NR_SYSCALL_BASE+242)	/* Added by C. Poellabauer --CP--.  */
+#define __NR_admission_control        	(__NR_SYSCALL_BASE+243)	/* Added by C. Poellabauer --CP--.  */
+
+/* Additional syscalls added for the ECalls mechanism. */
+#define __NR_start_ecalls             	(__NR_SYSCALL_BASE+244)	/* Added by C. Poellabauer --CP--.  */
+#define __NR_end_ecalls               	(__NR_SYSCALL_BASE+245)	/* Added by C. Poellabauer --CP--.  */
+#define __NR_register_ecall           	(__NR_SYSCALL_BASE+246)	/* Added by C. Poellabauer --CP--.  */
+#define __NR_do_downcall              	(__NR_SYSCALL_BASE+247)	/* Added by C. Poellabauer --CP--.  */
+#define __NR_run_event_handler        	(__NR_SYSCALL_BASE+248)	/* Added by C. Poellabauer --CP--.  */
+#define __NR_upcall_scheduler         	(__NR_SYSCALL_BASE+249)	/* Added by C. Poellabauer --CP--.  */
+#define __NR_wake_up_ecalls           	(__NR_SYSCALL_BASE+250)	/* Added by C. Poellabauer --CP--.  */
+#define __NR_download_code           	(__NR_SYSCALL_BASE+251)	/* Added by C. Poellabauer --CP--.  */
+
+/* Syscalls for user-level usage of KECho. */
+#define __NR_kecho_load		      	(__NR_SYSCALL_BASE+252)	/* Added by C. Poellabauer --CP--.  */
+#define __NR_KECho_syscall_echo       	(__NR_SYSCALL_BASE+253)	/* Added by C. Poellabauer --CP--.  */
+#define __NR_KECho_syscall_cm         	(__NR_SYSCALL_BASE+254)	/* Added by C. Poellabauer --CP--.  */
+#define __NR_KECho_syscall_cg         	(__NR_SYSCALL_BASE+255)	/* Added by C. Poellabauer --CP--.  */
+#define __NR_KECho_syscall_atl        	(__NR_SYSCALL_BASE+256)	/* Added by C. Poellabauer --CP--.  */
+#define __NR_KECho_sw_callback        	(__NR_SYSCALL_BASE+257)	/* Added by C. Poellabauer --CP--.  */
+
+/* Syscalls for measurment purposes. */
+#define __NR_getsyscalls              	(__NR_SYSCALL_BASE+258)	/* Added by C. Poellabauer --CP--.  */
+#define __NR_qos_configure            	(__NR_SYSCALL_BASE+259)	/* Added by C. Poellabauer --CP--.  */
+#define __NR_change_clock            	(__NR_SYSCALL_BASE+260)	/* Added by C. Poellabauer --CP--.  */
+
+/* Fast system call definitions. */
+#define __NR_fast_read                	(__NR_SYSCALL_BASE+3)	/* Added by C. Poellabauer --CP--.  */
+#define __NR_fast_do_downcall         	(__NR_SYSCALL_BASE+247)	/* Added by C. Poellabauer --CP--.  */
+#define __NR_fast_KECho_syscall_echo    (__NR_SYSCALL_BASE+253)	/* Added by C. Poellabauer --CP--.  */
+#define __NR_fast_KECho_syscall_cm      (__NR_SYSCALL_BASE+254)	/* Added by C. Poellabauer --CP--.  */
+#define __NR_fast_KECho_syscall_cg      (__NR_SYSCALL_BASE+255)	/* Added by C. Poellabauer --CP--.  */
+#define __NR_fast_KECho_syscall_atl     (__NR_SYSCALL_BASE+256)	/* Added by C. Poellabauer --CP--.  */
+
 /*
  * Please check 2.5 _before_ adding calls here,
  * and copy changes to rmk@arm.linux.org.uk.  Thanks.
diff -Naur test-for-latech/include/asm-i386/current.h testqf-for-latech/include/asm-i386/current.h
--- test-for-latech/include/asm-i386/current.h	2004-06-11 07:40:12.000000000 -0400
+++ testqf-for-latech/include/asm-i386/current.h	2004-06-11 07:47:30.000000000 -0400
@@ -3,13 +3,35 @@
 
 struct task_struct;
 
+#ifdef CONFIG_QFABRIC
+extern int ECalls_current_flag;
+extern struct task_struct *ECalls_current;
+
+static inline struct task_struct * original_get_current(void)
+{
+	struct task_struct *current;
+
+	__asm__("andl %%esp,%0; ":"=r" (current) : "0" (~8191UL));
+	return current;
+}
+
+#define original_current original_get_current()
+
+static inline struct task_struct * get_current(void)
+{
+	if (ECalls_current_flag == 1) 
+		return ECalls_current;
+	return original_get_current();
+}
+#else
 static inline struct task_struct * get_current(void)
 {
 	struct task_struct *current;
 	__asm__("andl %%esp,%0; ":"=r" (current) : "0" (~8191UL));
 	return current;
- }
- 
+}
+#endif
+
 #define current get_current()
 
 #endif /* !(_I386_CURRENT_H) */
diff -Naur test-for-latech/include/asm-i386/errno.h testqf-for-latech/include/asm-i386/errno.h
--- test-for-latech/include/asm-i386/errno.h	2004-06-11 07:40:12.000000000 -0400
+++ testqf-for-latech/include/asm-i386/errno.h	2004-06-11 07:47:30.000000000 -0400
@@ -129,4 +129,8 @@
 #define	ENOMEDIUM	123	/* No medium found */
 #define	EMEDIUMTYPE	124	/* Wrong medium type */
 
+#ifdef CONFIG_DWCS
+#define EADMISSION	125	/* Task admission denied. */
+#endif
+
 #endif
diff -Naur test-for-latech/include/asm-i386/hw_irq.h testqf-for-latech/include/asm-i386/hw_irq.h
--- test-for-latech/include/asm-i386/hw_irq.h	2004-06-11 07:40:12.000000000 -0400
+++ testqf-for-latech/include/asm-i386/hw_irq.h	2004-06-11 07:47:30.000000000 -0400
@@ -23,6 +23,9 @@
 #define FIRST_EXTERNAL_VECTOR	0x20
 
 #define SYSCALL_VECTOR		0x80
+#ifdef CONFIG_QFABRIC
+#define FAST_SYSCALL_VECTOR	0x60
+#endif
 
 /*
  * Vectors 0x20-0x2f are used for ISA interrupts.
diff -Naur test-for-latech/include/asm-i386/ptrace.h testqf-for-latech/include/asm-i386/ptrace.h
--- test-for-latech/include/asm-i386/ptrace.h	2004-06-11 07:40:12.000000000 -0400
+++ testqf-for-latech/include/asm-i386/ptrace.h	2004-06-11 07:47:30.000000000 -0400
@@ -1,6 +1,7 @@
 #ifndef _I386_PTRACE_H
 #define _I386_PTRACE_H
 
+#ifndef QFABRIC_DCG
 #define EBX 0
 #define ECX 1
 #define EDX 2
@@ -19,6 +20,7 @@
 #define UESP 15
 #define SS   16
 #define FRAME_SIZE 17
+#endif
 
 /* this struct defines the way the registers are stored on the 
    stack during a system call. */
diff -Naur test-for-latech/include/asm-i386/socket.h testqf-for-latech/include/asm-i386/socket.h
--- test-for-latech/include/asm-i386/socket.h	2004-06-11 07:40:12.000000000 -0400
+++ testqf-for-latech/include/asm-i386/socket.h	2004-06-11 07:47:30.000000000 -0400
@@ -45,6 +45,11 @@
 
 #define SO_ACCEPTCONN		30
 
+#ifdef CONFIG_QFABRIC
+#define	SO_QOS_PRIORITY		1000
+#define SO_QOS_DEADLINE		1001
+#endif
+
 /* Nasty libc5 fixup - bletch */
 #if defined(__KERNEL__) || !defined(__GLIBC__) || (__GLIBC__ < 2)
 /* Socket types. */
diff -Naur test-for-latech/include/asm-i386/uaccess.h testqf-for-latech/include/asm-i386/uaccess.h
--- test-for-latech/include/asm-i386/uaccess.h	2004-06-11 07:40:12.000000000 -0400
+++ testqf-for-latech/include/asm-i386/uaccess.h	2004-06-11 07:47:30.000000000 -0400
@@ -7,10 +7,21 @@
 #include <linux/config.h>
 #include <linux/sched.h>
 #include <linux/prefetch.h>
+#ifdef CONFIG_QFABRIC
+#include <asm/current.h>
+#endif
 #include <asm/page.h>
 
 #define VERIFY_READ 0
 #define VERIFY_WRITE 1
+#ifdef CONFIG_QFABRIC
+#ifndef NR_THREADS
+#define NR_THREADS 512
+#endif
+
+extern mm_segment_t kernel_get_fs(void);
+extern int kernel_access_ok(int type, const void *addr, size_t size);
+#endif
 
 /*
  * The fs value determines whether argument validity checking should be
@@ -27,7 +38,15 @@
 #define USER_DS		MAKE_MM_SEG(PAGE_OFFSET)
 
 #define get_ds()	(KERNEL_DS)
+#ifdef CONFIG_QFABRIC
+#ifdef MODULE
+#define get_fs()	(current->addr_limit)
+#else
+#define get_fs()	kernel_get_fs()
+#endif
+#else
 #define get_fs()	(current->addr_limit)
+#endif
 #define set_fs(x)	(current->addr_limit = (x))
 
 #define segment_eq(a,b)	((a).seg == (b).seg)
@@ -35,7 +54,7 @@
 extern int __verify_write(const void *, unsigned long);
 
 #define __addr_ok(addr) ((unsigned long)(addr) < (current->addr_limit.seg))
-
+			
 /*
  * Uhhuh, this needs 33-bit arithmetic. We have a carry..
  */
@@ -46,6 +65,24 @@
 		:"1" (addr),"g" ((int)(size)),"g" (current->addr_limit.seg)); \
 	flag; })
 
+#ifdef CONFIG_QFABRIC 
+#ifdef MODULE
+#ifdef CONFIG_X86_WP_WORKS_OK
+
+#define access_ok(type,addr,size) (__range_ok(addr,size) == 0)
+
+#else
+
+#define access_ok(type,addr,size) ( (__range_ok(addr,size) == 0) && \
+			 ((type) == VERIFY_READ || boot_cpu_data.wp_works_ok || \
+			 segment_eq(get_fs(),KERNEL_DS) || \
+			  __verify_write((void *)(addr),(size))))
+
+#endif
+#else
+#define access_ok(type,addr,size) kernel_access_ok(type,addr,size)
+#endif
+#else
 #ifdef CONFIG_X86_WP_WORKS_OK
 
 #define access_ok(type,addr,size) (__range_ok(addr,size) == 0)
@@ -58,6 +95,7 @@
 			  __verify_write((void *)(addr),(size))))
 
 #endif
+#endif
 
 static inline int verify_area(int type, const void * addr, unsigned long size)
 {
@@ -149,12 +187,12 @@
 
 #define __put_user_check(x,ptr,size)			\
 ({							\
-	long __pu_err = -EFAULT;					\
+	long __pu_err = -EFAULT;			\
 	__typeof__(*(ptr)) *__pu_addr = (ptr);		\
 	if (access_ok(VERIFY_WRITE,__pu_addr,size))	\
 		__put_user_size((x),__pu_addr,(size),__pu_err);	\
 	__pu_err;					\
-})							
+})	
 
 #define __put_user_u64(x, addr, err)				\
 	__asm__ __volatile__(					\
@@ -308,6 +346,12 @@
 static inline unsigned long
 __generic_copy_from_user_nocheck(void *to, const void *from, unsigned long n)
 {
+#ifdef CONFIG_QFABRIC
+	if (current->uaccess_flag == 1) {
+		memcpy(to, from, n);
+		return 0;
+	}
+#endif
 	__copy_user_zeroing(to,from,n);
 	return n;
 }
@@ -315,6 +359,12 @@
 static inline unsigned long
 __generic_copy_to_user_nocheck(void *to, const void *from, unsigned long n)
 {
+#ifdef CONFIG_QFABRIC
+	if (current->uaccess_flag == 1) {
+		memcpy(to, from, n);
+		return 0;
+	}
+#endif
 	__copy_user(to,from,n);
 	return n;
 }
@@ -546,6 +596,12 @@
 static inline unsigned long
 __constant_copy_to_user(void *to, const void *from, unsigned long n)
 {
+#ifdef CONFIG_QFABRIC
+	if (current->uaccess_flag == 1) {
+		memcpy(to, from, n);
+		return 0;
+	}
+#endif
 	prefetch(from);
 	if (access_ok(VERIFY_WRITE, to, n))
 		__constant_copy_user(to,from,n);
@@ -555,6 +611,12 @@
 static inline unsigned long
 __constant_copy_from_user(void *to, const void *from, unsigned long n)
 {
+#ifdef CONFIG_QFABRIC
+	if (current->uaccess_flag == 1) {
+		memcpy(to, from, n);
+		return 0;
+	}
+#endif
 	if (access_ok(VERIFY_READ, from, n))
 		__constant_copy_user_zeroing(to,from,n);
 	else
@@ -565,6 +627,12 @@
 static inline unsigned long
 __constant_copy_to_user_nocheck(void *to, const void *from, unsigned long n)
 {
+#ifdef CONFIG_QFABRIC
+	if (current->uaccess_flag == 1) {
+		memcpy(to, from, n);
+		return 0;
+	}
+#endif
 	__constant_copy_user(to,from,n);
 	return n;
 }
@@ -572,6 +640,12 @@
 static inline unsigned long
 __constant_copy_from_user_nocheck(void *to, const void *from, unsigned long n)
 {
+#ifdef CONFIG_QFABRIC
+	if (current->uaccess_flag == 1) {
+		memcpy(to, from, n);
+		return 0;
+	}
+#endif
 	__constant_copy_user_zeroing(to,from,n);
 	return n;
 }
diff -Naur test-for-latech/include/asm-i386/unistd.h testqf-for-latech/include/asm-i386/unistd.h
--- test-for-latech/include/asm-i386/unistd.h	2004-06-11 07:40:12.000000000 -0400
+++ testqf-for-latech/include/asm-i386/unistd.h	2004-06-11 07:47:29.000000000 -0400
@@ -1,5 +1,12 @@
 #ifndef _ASM_I386_UNISTD_H_
 #define _ASM_I386_UNISTD_H_
+#ifdef CONFIG_QFABRIC
+#include <linux/config.h>
+#endif
+
+#ifdef CONFIG_DWCS
+#define __NR_SYSCALL_BASE	0x00
+#endif
 
 /*
  * This file contains the system call numbers.
@@ -248,6 +255,45 @@
 #define __NR_sched_setaffinity	241
 #define __NR_sched_getaffinity	242
 
+/* Additional syscalls added for the dionisys resource manager. */
+#define __NR_load_scheduler     243     /* Added by Rich West --RW--.  */
+#define __NR_unload_scheduler   244     /* Added by Rich West --RW--.  */
+#define __NR_DWCS_scheduler     245     /* Added by Rich West --RW--.  */
+#define __NR_update_utilization 246     /* Added by C. Poellabauer --CP--.  */
+#define __NR_admission_control  247     /* Added by C. Poellabauer --CP--.  */
+/* Additional syscalls added for the ECalls mechanism. */
+#define __NR_start_ecalls       248     /* Added by C. Poellabauer --CP--.  */
+#define __NR_end_ecalls         249     /* Added by C. Poellabauer --CP--.  */
+#define __NR_register_ecall     250     /* Added by C. Poellabauer --CP--.  */
+#define __NR_do_downcall        251     /* Added by C. Poellabauer --CP--.  */
+#define __NR_run_event_handler  252     /* Added by C. Poellabauer --CP--.  */
+#define __NR_upcall_scheduler   253     /* Added by C. Poellabauer --CP--.  */
+#define __NR_wake_up_ecalls     254     /* Added by C. Poellabauer --CP--.  */
+#define __NR_download_code      255     /* Added by C. Poellabauer --CP--.  */
+
+/* Syscalls for user-level usage of KECho. */
+#define __NR_kecho_load		256 /* --CP-- */
+#define __NR_KECho_syscall_echo 257     /* Added by C. Poellabauer --CP--.  */
+#define __NR_KECho_syscall_cm   258     /* Added by C. Poellabauer --CP--.  */
+#define __NR_KECho_syscall_cg   259     /* Added by C. Poellabauer --CP--.  */
+#define __NR_KECho_syscall_atl  260     /* Added by C. Poellabauer --CP--.  */
+#define __NR_KECho_sw_callback  261     /* Added by C. Poellabauer --CP--.  */
+
+#define __NR_getsyscalls        262     /* Added by C. Poellabauer --CP--.  */
+#define __NR_qos_configure	263     /* Added by C. Poellabauer --CP--.  */
+#define __NR_change_clock	264     /* Added by C. Poellabauer --CP--.  */
+
+/* QSocket changes. */
+#define __NR_qsocketcall	265
+
+/* Fast system call definitions. */
+#define __NR_fast_read            3     /* Added by C. Poellabauer --CP--.  */
+#define __NR_fast_do_downcall   251     /* Added by C. Poellabauer --CP--.  */
+#define __NR_fast_KECho_syscall_echo 257 /* Added by C. Poellabauer --CP--.  */
+#define __NR_fast_KECho_syscall_cm   258 /* Added by C. Poellabauer --CP--.  */
+#define __NR_fast_KECho_syscall_cg   259 /* Added by C. Poellabauer --CP--.  */
+#define __NR_fast_KECho_syscall_atl  260 /* Added by C. Poellabauer --CP--.  */
+
 /* user-visible error numbers are in the range -1 - -124: see <asm-i386/errno.h> */
 
 #define __syscall_return(type, res) \
@@ -337,6 +383,71 @@
 __syscall_return(type,__res); \
 }
 
+/* Fast system calls. */
+#define _fast_syscall0(type,name) \
+type name(void) \
+{ \
+long __res; \
+__asm__ volatile ("int $0x60" \
+	: "=a" (__res) \
+	: "0" (__NR_##name)); \
+__syscall_return(type,__res); \
+}
+
+#define _fast_syscall1(type,name,type1,arg1) \
+type name(type1 arg1) \
+{ \
+long __res; \
+__asm__ volatile ("int $0x60" \
+	: "=a" (__res) \
+	: "0" (__NR_##name),"b" ((long)(arg1))); \
+__syscall_return(type,__res); \
+}
+
+#define _fast_syscall2(type,name,type1,arg1,type2,arg2) \
+type name(type1 arg1,type2 arg2) \
+{ \
+long __res; \
+__asm__ volatile ("int $0x60" \
+	: "=a" (__res) \
+	: "0" (__NR_##name),"b" ((long)(arg1)),"c" ((long)(arg2))); \
+__syscall_return(type,__res); \
+}
+
+#define _fast_syscall3(type,name,type1,arg1,type2,arg2,type3,arg3) \
+type name(type1 arg1,type2 arg2,type3 arg3) \
+{ \
+long __res; \
+__asm__ volatile ("int $0x60" \
+	: "=a" (__res) \
+	: "0" (__NR_##name),"b" ((long)(arg1)),"c" ((long)(arg2)), \
+		  "d" ((long)(arg3))); \
+__syscall_return(type,__res); \
+}
+
+#define _fast_syscall4(type,name,type1,arg1,type2,arg2,type3,arg3,type4,arg4) \
+type name (type1 arg1, type2 arg2, type3 arg3, type4 arg4) \
+{ \
+long __res; \
+__asm__ volatile ("int $0x60" \
+	: "=a" (__res) \
+	: "0" (__NR_##name),"b" ((long)(arg1)),"c" ((long)(arg2)), \
+	  "d" ((long)(arg3)),"S" ((long)(arg4))); \
+__syscall_return(type,__res); \
+} 
+
+#define _fast_syscall5(type,name,type1,arg1,type2,arg2,type3,arg3,type4,arg4, \
+	  type5,arg5) \
+type name (type1 arg1,type2 arg2,type3 arg3,type4 arg4,type5 arg5) \
+{ \
+long __res; \
+__asm__ volatile ("int $0x60" \
+	: "=a" (__res) \
+	: "0" (__NR_##name),"b" ((long)(arg1)),"c" ((long)(arg2)), \
+	  "d" ((long)(arg3)),"S" ((long)(arg4)),"D" ((long)(arg5))); \
+__syscall_return(type,__res); \
+}
+
 #ifdef __KERNEL_SYSCALLS__
 
 /*
diff -Naur test-for-latech/include/linux/ecalls.h testqf-for-latech/include/linux/ecalls.h
--- test-for-latech/include/linux/ecalls.h	1969-12-31 19:00:00.000000000 -0500
+++ testqf-for-latech/include/linux/ecalls.h	2004-06-11 07:47:29.000000000 -0400
@@ -0,0 +1,239 @@
+#ifndef	__ECALLS__H__
+#define	__ECALLS__H__
+
+#include <linux/ecalls-types.h>
+#include <string.h>
+
+/* system call: start_ecalls. */
+_syscall1(int, start_ecalls,
+	  int, flag);
+
+/* system call: end_ecalls. */
+_syscall0(int, end_ecalls);
+
+/* system call: register_ecall. */
+_syscall4(int, register_ecall,
+          char *, service,
+	  int, len,
+          struct ecall_down *, downcall,
+          struct ecall_up *, upcall);
+
+/* system call: download code. */
+_syscall5(int, download_code,
+	  char *, hookname,
+	  char *, parameter1,
+	  int, parameter2,
+	  int, parameter3,
+	  char *, code);
+
+/* system call: do_downcall. */
+_syscall3(int, do_downcall,
+          struct ecall_down *, downcall,
+	  void *, data,
+	  int, len);
+
+#ifdef CONFIG_X86
+/* fast system call: fast_do_downcall. */
+_fast_syscall3(int, fast_do_downcall,
+	  struct ecall_down *, downcall,
+	  void *, data,
+ 	  int, len);
+#endif
+
+/* Start ECalls. */
+int ECalls_start(int flag)
+{
+  start_ecalls(flag);
+
+  return 0;
+}
+
+/* End ECalls. */
+int ECalls_cancel(struct ecall_down *downcall, struct ecall_up *upcall)
+{
+  end_ecalls();
+
+  return 0;
+}
+
+/* Initialize downcall data structure. */
+int init_downcall(char *service_name, struct ecall_down *downcall, 
+	void *down_ptr)
+{
+  if (down_ptr != NULL) {
+    if (downcall->size1 > 0) {
+      if (downcall->size2 > 0) {
+        downcall->flag = (unsigned long) down_ptr;
+        downcall->bitpattern = downcall->flag + sizeof(int);
+        downcall->front = 0;
+        downcall->back = 0;
+        downcall->data = (unsigned long) downcall->bitpattern + 
+	  sizeof(unsigned long)*
+	  downcall->size2;
+        downcall->total_size = downcall->size1;
+        downcall->service_name = strdup(service_name);
+        downcall->string_len = strlen(service_name);
+      } else {
+        downcall->flag = (unsigned long) down_ptr;
+        downcall->bitpattern = 0;
+        downcall->front = (unsigned long) downcall->flag + sizeof(int);
+        downcall->back = (unsigned long) downcall->back + sizeof(int);
+        downcall->total_size = downcall->size1;
+        downcall->service_name = strdup(service_name);
+        downcall->string_len = strlen(service_name);
+      }
+    } else {
+      downcall->flag = 0;
+      downcall->bitpattern = 0;
+      downcall->front = 0;
+      downcall->back = 0;
+      downcall->data = 0;
+      downcall->total_size = sizeof(int);
+      downcall->service_name = strdup(service_name);
+      downcall->string_len = strlen(service_name);
+    }
+  } else {
+    downcall->flag = 0;
+    downcall->bitpattern = 0;
+    downcall->front = 0;
+    downcall->back = 0;
+    downcall->data = 0;
+    downcall->total_size = sizeof(int);
+    downcall->service_name = strdup(service_name);
+    downcall->string_len = strlen(service_name);
+  } 
+  return 0;
+}
+
+/* Initialize upcall data structure. */
+int init_upcall(char *service_name, struct ecall_up *upcall, void *up_ptr)
+{
+  if (up_ptr != NULL) {
+    if (upcall->size1 > 0) {
+      if (upcall->size2 > 0) {
+        upcall->flag = (unsigned long) up_ptr;
+        upcall->bitpattern = (unsigned long) upcall->flag + sizeof(int);
+        upcall->front = 0;
+        upcall->back = 0;
+        upcall->data = (unsigned long)upcall->bitpattern + 
+		sizeof(unsigned long)*upcall->size2;
+        upcall->total_size = upcall->size1;
+        upcall->service_name = strdup(service_name);
+        upcall->string_len = strlen(service_name);
+      } else {
+        upcall->flag = (unsigned long) up_ptr;
+        upcall->bitpattern = 0;
+        upcall->front = (unsigned long) upcall->flag + sizeof(int);
+        upcall->back = (unsigned long) upcall->back + sizeof(int);
+        upcall->total_size = upcall->size1;
+        upcall->service_name = strdup(service_name);
+        upcall->string_len = strlen(service_name);
+      }
+    } else {
+      upcall->flag = 0;
+      upcall->bitpattern = 0;
+      upcall->front = 0;
+      upcall->back = 0;
+      upcall->data = 0;
+      upcall->total_size = 0;
+    }
+  } else {
+    upcall->flag = 0;
+    upcall->bitpattern = 0;
+    upcall->front = 0;
+    upcall->back = 0;
+    upcall->data = 0;
+    upcall->total_size = 0;
+  }
+  return 0;
+}
+
+/* Initialize ECalls. */
+int ECalls_init(char *service_name, struct ecall_down *downcall,
+  struct ecall_up *upcall, int signal, int pid, void *u_handler, 
+  void *k_handler)
+{
+  if (service_name == NULL) return -1;
+
+  upcall->service_name = strdup(service_name);
+  upcall->string_len = strlen(service_name);
+  upcall->signal = signal;
+  upcall->process_id = pid; 
+  upcall->handler_function = u_handler;
+  upcall->kernel_function = k_handler;
+  upcall->kfct_string_len = 0;
+  if (upcall->kernel_function != NULL)
+    upcall->kfct_string_len = strlen(upcall->kernel_function);
+  return 0;
+}
+
+/* Unregister ECalls. */
+int ECalls_unsubscribe(char *service_name) 
+{
+  register_ecall(service_name, 
+    strlen(service_name),NULL, NULL);
+  return 0;
+}
+
+/* Register ECalls. */
+int ECalls_subscribe(char *service_name,
+  struct ecall_down *downcall, void *down_ptr, 
+  struct ecall_up *upcall, void *up_ptr)
+{
+  int id;
+
+  if (service_name == NULL) return -1;
+
+  if (downcall != NULL) 
+    init_downcall(service_name, downcall, down_ptr);
+
+  if (upcall != NULL) 
+    init_upcall(service_name, upcall, up_ptr);
+
+  if ((id = register_ecall(service_name,
+    strlen(service_name),downcall,upcall)) < 0)
+    return -1;
+
+  if (downcall != NULL) { 
+    if (downcall->total_size > 0)
+      downcall->service_id = id;
+  }
+
+  if (upcall != NULL) { 
+    if (upcall->total_size > 0)
+      upcall->service_id = id;
+  }
+
+  return 0;
+}
+
+/* Submit Event. */
+int ECalls_submit_event(struct ecall_down *downcall, void *event, int len,
+	int type)
+{
+  if ((type == DEFERRED) || (type == NORMAL)) {
+    (*(int *)downcall->flag)++;
+  }
+  else if (type == SYSCALL) {
+    do_downcall(downcall, event, len);
+  }
+#ifdef CONFIG_X86
+  else if (type == IMMEDIATE) {
+    (*(int *)downcall->flag)++;
+    fast_do_downcall(downcall, event, len);
+  }
+#endif
+
+  return 0;
+}
+
+/* Download extension code. */
+int ECalls_download(char *hookname, char *parameter1, int parameter2, 
+	int parameter3, char *code)
+{
+  download_code(hookname, parameter1, parameter2, parameter3, code);
+
+  return 0;
+}
+
+#endif /* __ECALLS__H__ */
diff -Naur test-for-latech/include/linux/ecalls-types.h testqf-for-latech/include/linux/ecalls-types.h
--- test-for-latech/include/linux/ecalls-types.h	1969-12-31 19:00:00.000000000 -0500
+++ testqf-for-latech/include/linux/ecalls-types.h	2004-06-11 07:47:29.000000000 -0400
@@ -0,0 +1,70 @@
+#ifndef	__ECALLS_TYPES__H__
+#define	__ECALLS_TYPES__H__
+
+#include <sys/syscall.h>
+#include <linux/a.out.h>
+#include <sys/mman.h>
+#include <sys/time.h>
+#include <sys/types.h>
+#include <errno.h>
+#include <malloc.h>
+#include <unistd.h>
+
+#define DEF_EVENT_NUM 32
+#define DEF_EVENT_SIZE sizeof(int)
+#define DEF_MEM_SIZE 512
+#define FLAG_ONLY 0
+#define GENERAL_EVENTS 1
+#define PRIORITY_EVENTS 2
+#define NORMAL 0
+#define SYSCALL 1
+#define IMMEDIATE 2
+#define DEFERRED 3
+
+struct ecall_down {
+	int service_id;
+	unsigned long flag;
+	unsigned long bitpattern;
+	unsigned long front;
+	unsigned long back;
+	unsigned long data;
+	char *service_name;
+        int string_len;
+	int total_size;
+	int size1;
+	int size2;
+};
+typedef struct ecall_down *t_downcall_data;
+
+struct ecall_up {
+	int service_id;
+	unsigned long flag;
+	unsigned long bitpattern;
+	unsigned long front;
+	unsigned long back;
+	unsigned long data;
+	char *service_name;
+        int string_len;
+        int kfct_string_len;
+	int total_size;
+	int process_id;
+	int signal;
+    	void *handler_function;
+    	char *kernel_function;
+	int size1;
+	int size2;
+};
+typedef struct ecall_up *t_upcall_data;
+
+extern int ECalls_start(int);
+extern int ECalls_end(struct ecall_down *, struct ecall_up *);
+extern int init_downcall(char *, struct ecall_down *, void *);
+extern int init_upcall(char *, struct ecall_up *, void *);
+extern int ECalls_subscribe(char *, struct ecall_down *, void *,
+		struct ecall_up *, void *);
+extern int ECalls_cancel(struct ecall_down *, struct ecall_up *);
+extern int ECalls_submit_event(struct ecall_down *, void *, int,
+	int);
+extern int ECalls_init(char *, struct ecall_down *,
+  struct ecall_up *, int, int, void *, void *);
+#endif /* __ECALLS_TYPES__H__ */
diff -Naur test-for-latech/include/linux/fastcalls.h testqf-for-latech/include/linux/fastcalls.h
--- test-for-latech/include/linux/fastcalls.h	1969-12-31 19:00:00.000000000 -0500
+++ testqf-for-latech/include/linux/fastcalls.h	2004-06-11 07:47:29.000000000 -0400
@@ -0,0 +1,13 @@
+#ifndef	__FASTCALLS__H__
+#define	__FASTCALLS__H__
+
+#include <sys/syscall.h>
+#include <sys/types.h>
+#include <errno.h>
+
+_fast_syscall3(int, fast_read,
+	  int, fd,
+	  void *, buffer,
+ 	  int, len);
+
+#endif /* __FASTCALLS__H__ */
diff -Naur test-for-latech/include/linux/libqsocket.h testqf-for-latech/include/linux/libqsocket.h
--- test-for-latech/include/linux/libqsocket.h	1969-12-31 19:00:00.000000000 -0500
+++ testqf-for-latech/include/linux/libqsocket.h	2004-06-11 07:47:29.000000000 -0400
@@ -0,0 +1,28 @@
+#include <stdio.h>
+#include <dlfcn.h>
+#include <sys/types.h>
+#include <sys/socket.h>
+#include <sys/syscall.h>
+#include <linux/unistd.h>
+#include <linux/net.h>
+#include <asm/types.h>
+#include <linux/netlink.h>
+#include <linux/rtnetlink.h>
+#include <linux/qos_conf.h>
+#include <errno.h>
+#include <netinet/in.h>
+#include <sys/socket.h>
+#include <qsocket.h>
+
+
+int qsocket(int, int, int, struct qos_params *);
+int qclose(int);
+int qchange(int, struct qos_params*);
+int qsendto(int fd, void *buff, size_t len, unsigned int flags,
+			struct sockaddr *addr, int addr_len,
+			struct packet_flags *pflags);
+int qsend(int fd, void *buff, size_t len, unsigned int flags,
+			struct packet_flags *pflags);
+int qinfo(int fd, struct qsocket_info *info);
+int qchannel(int fd, int server);
+int qinit(struct qos_params *params);
diff -Naur test-for-latech/include/linux/netdevice.h testqf-for-latech/include/linux/netdevice.h
--- test-for-latech/include/linux/netdevice.h	2004-06-11 07:40:03.000000000 -0400
+++ testqf-for-latech/include/linux/netdevice.h	2004-06-11 07:47:24.000000000 -0400
@@ -431,6 +431,10 @@
 	/* this will get initialized at each interface type init routine */
 	struct divert_blk	*divert;
 #endif /* CONFIG_NET_DIVERT */
+#ifdef CONFIG_QFABRIC
+	int rte_list;
+	int rte_list_len;
+#endif
 };
 
 
@@ -579,6 +583,9 @@
 #define HAVE_NETIF_RX 1
 extern int		netif_rx(struct sk_buff *skb);
 extern int		dev_ioctl(unsigned int cmd, void *);
+#ifdef CONFIG_QFABRIC
+extern int		dev_ioctl2(unsigned int cmd, void *, int flag);
+#endif
 extern int		dev_change_flags(struct net_device *, unsigned);
 extern void		dev_queue_xmit_nit(struct sk_buff *skb, struct net_device *dev);
 
diff -Naur test-for-latech/include/linux/net.h testqf-for-latech/include/linux/net.h
--- test-for-latech/include/linux/net.h	2004-06-11 07:40:06.000000000 -0400
+++ testqf-for-latech/include/linux/net.h	2004-06-11 07:47:24.000000000 -0400
@@ -44,7 +44,9 @@
 #define SYS_GETSOCKOPT	15		/* sys_getsockopt(2)		*/
 #define SYS_SENDMSG	16		/* sys_sendmsg(2)		*/
 #define SYS_RECVMSG	17		/* sys_recvmsg(2)		*/
-
+#ifdef CONFIG_QFABRIC
+#define SYS_RTSOCKET    18		/* sys_rtsocket			*/
+#endif
 
 typedef enum {
   SS_FREE = 0,				/* not allocated		*/
@@ -76,6 +78,12 @@
 
 	short			type;
 	unsigned char		passcred;
+
+#ifdef CONFIG_QFABRIC
+	int 			rt_sock;
+	int			deadline;
+	int 			rt_flags;
+#endif
 };
 
 #define SOCK_INODE(S)	((S)->inode)
@@ -134,8 +142,15 @@
 extern int	sock_unregister(int family);
 extern struct socket *sock_alloc(void);
 extern int	sock_create(int family, int type, int proto, struct socket **);
+#ifdef CONFIG_QFABRIC
+extern int	make_rt_sock(struct socket *);
+#endif
 extern void	sock_release(struct socket *);
 extern int   	sock_sendmsg(struct socket *, struct msghdr *m, int len);
+#ifdef CONFIG_QFABRIC
+extern int   	rt_sock_sendmsg(struct socket *, struct msghdr *m, int len,
+	int deadline, int flags);
+#endif
 extern int	sock_recvmsg(struct socket *, struct msghdr *m, int len, int flags);
 extern int	sock_readv_writev(int type, struct inode * inode, struct file * file,
 				  const struct iovec * iov, long count, long size);
diff -Naur test-for-latech/include/linux/pkt_cls.h testqf-for-latech/include/linux/pkt_cls.h
--- test-for-latech/include/linux/pkt_cls.h	2004-06-11 07:40:08.000000000 -0400
+++ testqf-for-latech/include/linux/pkt_cls.h	2004-06-11 07:47:28.000000000 -0400
@@ -158,4 +158,16 @@
 
 #define TCA_TCINDEX_MAX        TCA_TCINDEX_POLICE
 
+enum
+{
+	TCA_SOCKET_UNSPEC,
+	TCA_SOCKET_CLASSID,
+	TCA_SOCKET_PROCESSID,
+	TCA_SOCKET_FDID,
+	TCA_SOCKET_INODEID,
+	TCA_SOCKET_POLICE,
+};
+
+#define TCA_SOCKET_MAX TCA_SOCKET_POLICE
+
 #endif
diff -Naur test-for-latech/include/linux/pkt_sched.h testqf-for-latech/include/linux/pkt_sched.h
--- test-for-latech/include/linux/pkt_sched.h	2004-06-11 07:40:08.000000000 -0400
+++ testqf-for-latech/include/linux/pkt_sched.h	2004-06-11 07:47:28.000000000 -0400
@@ -93,6 +93,26 @@
 	__u32	limit;	/* Queue length: bytes for bfifo, packets for pfifo */
 };
 
+/* DWCS section */
+struct tc_dwcs_qopt
+{
+	__u32 limit;
+};
+
+enum
+{
+	TCA_DWCS_UNSPEC,
+	TCA_DWCS_DEADLINE,
+	TCA_DWCS_OLN,
+	TCA_DWCS_OLD,
+#define DWCS_FLAG1	0x00000002
+#define DWCS_FLAG2	0x00000004
+	TCA_DWCS_FLAGS,
+	TCA_DWCS_POLICE,
+};
+
+#define TCA_DWCS_MAX TCA_DWCS_POLICE
+
 /* PRIO section */
 
 #define TCQ_PRIO_BANDS	16
